// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from ublox_ubx_msgs:msg/PSMStatus.idl
// generated code does not contain a copyright notice
#include "ublox_ubx_msgs/msg/detail/psm_status__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


bool
ublox_ubx_msgs__msg__PSMStatus__init(ublox_ubx_msgs__msg__PSMStatus * msg)
{
  if (!msg) {
    return false;
  }
  // state
  return true;
}

void
ublox_ubx_msgs__msg__PSMStatus__fini(ublox_ubx_msgs__msg__PSMStatus * msg)
{
  if (!msg) {
    return;
  }
  // state
}

bool
ublox_ubx_msgs__msg__PSMStatus__are_equal(const ublox_ubx_msgs__msg__PSMStatus * lhs, const ublox_ubx_msgs__msg__PSMStatus * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // state
  if (lhs->state != rhs->state) {
    return false;
  }
  return true;
}

bool
ublox_ubx_msgs__msg__PSMStatus__copy(
  const ublox_ubx_msgs__msg__PSMStatus * input,
  ublox_ubx_msgs__msg__PSMStatus * output)
{
  if (!input || !output) {
    return false;
  }
  // state
  output->state = input->state;
  return true;
}

ublox_ubx_msgs__msg__PSMStatus *
ublox_ubx_msgs__msg__PSMStatus__create()
{
  ublox_ubx_msgs__msg__PSMStatus * msg = (ublox_ubx_msgs__msg__PSMStatus *)malloc(sizeof(ublox_ubx_msgs__msg__PSMStatus));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(ublox_ubx_msgs__msg__PSMStatus));
  bool success = ublox_ubx_msgs__msg__PSMStatus__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
ublox_ubx_msgs__msg__PSMStatus__destroy(ublox_ubx_msgs__msg__PSMStatus * msg)
{
  if (msg) {
    ublox_ubx_msgs__msg__PSMStatus__fini(msg);
  }
  free(msg);
}


bool
ublox_ubx_msgs__msg__PSMStatus__Sequence__init(ublox_ubx_msgs__msg__PSMStatus__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  ublox_ubx_msgs__msg__PSMStatus * data = NULL;
  if (size) {
    data = (ublox_ubx_msgs__msg__PSMStatus *)calloc(size, sizeof(ublox_ubx_msgs__msg__PSMStatus));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = ublox_ubx_msgs__msg__PSMStatus__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        ublox_ubx_msgs__msg__PSMStatus__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
ublox_ubx_msgs__msg__PSMStatus__Sequence__fini(ublox_ubx_msgs__msg__PSMStatus__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      ublox_ubx_msgs__msg__PSMStatus__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

ublox_ubx_msgs__msg__PSMStatus__Sequence *
ublox_ubx_msgs__msg__PSMStatus__Sequence__create(size_t size)
{
  ublox_ubx_msgs__msg__PSMStatus__Sequence * array = (ublox_ubx_msgs__msg__PSMStatus__Sequence *)malloc(sizeof(ublox_ubx_msgs__msg__PSMStatus__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = ublox_ubx_msgs__msg__PSMStatus__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
ublox_ubx_msgs__msg__PSMStatus__Sequence__destroy(ublox_ubx_msgs__msg__PSMStatus__Sequence * array)
{
  if (array) {
    ublox_ubx_msgs__msg__PSMStatus__Sequence__fini(array);
  }
  free(array);
}

bool
ublox_ubx_msgs__msg__PSMStatus__Sequence__are_equal(const ublox_ubx_msgs__msg__PSMStatus__Sequence * lhs, const ublox_ubx_msgs__msg__PSMStatus__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!ublox_ubx_msgs__msg__PSMStatus__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
ublox_ubx_msgs__msg__PSMStatus__Sequence__copy(
  const ublox_ubx_msgs__msg__PSMStatus__Sequence * input,
  ublox_ubx_msgs__msg__PSMStatus__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(ublox_ubx_msgs__msg__PSMStatus);
    ublox_ubx_msgs__msg__PSMStatus * data =
      (ublox_ubx_msgs__msg__PSMStatus *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!ublox_ubx_msgs__msg__PSMStatus__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          ublox_ubx_msgs__msg__PSMStatus__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!ublox_ubx_msgs__msg__PSMStatus__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
