// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from ublox_ubx_msgs:msg/UBXNavPVT.idl
// generated code does not contain a copyright notice

#ifndef UBLOX_UBX_MSGS__MSG__DETAIL__UBX_NAV_PVT__STRUCT_H_
#define UBLOX_UBX_MSGS__MSG__DETAIL__UBX_NAV_PVT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'gps_fix'
#include "ublox_ubx_msgs/msg/detail/gps_fix__struct.h"
// Member 'psm'
#include "ublox_ubx_msgs/msg/detail/psmpvt__struct.h"
// Member 'carr_soln'
#include "ublox_ubx_msgs/msg/detail/carr_soln__struct.h"

// Struct defined in msg/UBXNavPVT in the package ublox_ubx_msgs.
typedef struct ublox_ubx_msgs__msg__UBXNavPVT
{
  std_msgs__msg__Header header;
  uint32_t itow;
  uint16_t year;
  uint8_t month;
  uint8_t day;
  uint8_t hour;
  uint8_t min;
  uint8_t sec;
  bool valid_date;
  bool valid_time;
  bool fully_resolved;
  bool valid_mag;
  uint32_t t_acc;
  int32_t nano;
  ublox_ubx_msgs__msg__GpsFix gps_fix;
  bool gnss_fix_ok;
  bool diff_soln;
  ublox_ubx_msgs__msg__PSMPVT psm;
  bool head_veh_valid;
  ublox_ubx_msgs__msg__CarrSoln carr_soln;
  bool confirmed_avail;
  bool confirmed_date;
  bool confirmed_time;
  uint8_t num_sv;
  int32_t lon;
  int32_t lat;
  int32_t height;
  int32_t hmsl;
  uint32_t h_acc;
  uint32_t v_acc;
  int32_t vel_n;
  int32_t vel_e;
  int32_t vel_d;
  int32_t g_speed;
  int32_t head_mot;
  uint32_t s_acc;
  uint32_t head_acc;
  uint16_t p_dop;
  bool invalid_llh;
  int32_t head_veh;
  int16_t mag_dec;
  uint16_t mag_acc;
} ublox_ubx_msgs__msg__UBXNavPVT;

// Struct for a sequence of ublox_ubx_msgs__msg__UBXNavPVT.
typedef struct ublox_ubx_msgs__msg__UBXNavPVT__Sequence
{
  ublox_ubx_msgs__msg__UBXNavPVT * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} ublox_ubx_msgs__msg__UBXNavPVT__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // UBLOX_UBX_MSGS__MSG__DETAIL__UBX_NAV_PVT__STRUCT_H_
